<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>polylib: Matop.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.1 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="main.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>File&nbsp;Members</span></a></li>
    </ul>
  </div>
<h1>Matop.c</h1><a href="Matop_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    This file is part of PolyLib.</span>
<a name="l00003"></a>00003 <span class="comment"></span>
<a name="l00004"></a>00004 <span class="comment">    PolyLib is free software: you can redistribute it and/or modify</span>
<a name="l00005"></a>00005 <span class="comment">    it under the terms of the GNU General Public License as published by</span>
<a name="l00006"></a>00006 <span class="comment">    the Free Software Foundation, either version 3 of the License, or</span>
<a name="l00007"></a>00007 <span class="comment">    (at your option) any later version.</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">    PolyLib is distributed in the hope that it will be useful,</span>
<a name="l00010"></a>00010 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00011"></a>00011 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span>
<a name="l00012"></a>00012 <span class="comment">    GNU General Public License for more details.</span>
<a name="l00013"></a>00013 <span class="comment"></span>
<a name="l00014"></a>00014 <span class="comment">    You should have received a copy of the GNU General Public License</span>
<a name="l00015"></a>00015 <span class="comment">    along with PolyLib.  If not, see &lt;http://www.gnu.org/licenses/&gt;.</span>
<a name="l00016"></a>00016 <span class="comment">*/</span>
<a name="l00017"></a>00017 
<a name="l00018"></a>00018 <span class="preprocessor">#include &lt;stdlib.h&gt;</span>
<a name="l00019"></a>00019 <span class="preprocessor">#include &lt;<a class="code" href="polylib_8h.html">polylib/polylib.h</a>&gt;</span>
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">/* computes c = lcm(a,b) using Gcd(a,b,&amp;c) */</span>
<a name="l00022"></a><a class="code" href="Matop_8h.html#a69ef60460903eaa2378b40e13181e565">00022</a> <span class="keywordtype">void</span> <a class="code" href="Matop_8c.html#a69ef60460903eaa2378b40e13181e565">Lcm3</a>(Value a, Value b, Value *c)
<a name="l00023"></a>00023 {
<a name="l00024"></a>00024   Value tmp;
<a name="l00025"></a>00025 
<a name="l00026"></a>00026   <span class="keywordflow">if</span> (<a class="code" href="source_2arith_2arithmetique_8h.html#a827532f2140ae2aa96e46baebae09723">value_zero_p</a>(a)) {
<a name="l00027"></a>00027     <a class="code" href="source_2arith_2arithmetique_8h.html#a864613888dc46f15679aa4f63e468f89">value_assign</a>(*c, b);
<a name="l00028"></a>00028     <span class="keywordflow">return</span>;
<a name="l00029"></a>00029   }
<a name="l00030"></a>00030   <span class="keywordflow">if</span> (<a class="code" href="source_2arith_2arithmetique_8h.html#a827532f2140ae2aa96e46baebae09723">value_zero_p</a>(b)) {
<a name="l00031"></a>00031     <a class="code" href="source_2arith_2arithmetique_8h.html#a864613888dc46f15679aa4f63e468f89">value_assign</a>(*c, a);
<a name="l00032"></a>00032     <span class="keywordflow">return</span>;
<a name="l00033"></a>00033   }
<a name="l00034"></a>00034   <a class="code" href="source_2arith_2arithmetique_8h.html#af71a2ca0294a19cff0cdcbdcc052ee27">value_init</a>(tmp);
<a name="l00035"></a>00035   <a class="code" href="source_2arith_2arithmetique_8h.html#ac9986d34264874727344f666079e2294">value_multiply</a>(tmp, a, b);
<a name="l00036"></a>00036   <a class="code" href="source_2arith_2arithmetique_8h.html#a6eee595d027bdf64a6c529b5f138720f">value_absolute</a>(tmp, tmp);
<a name="l00037"></a>00037   <a class="code" href="vector_8c.html#a465a286010ac5724a37644eff2922d76">Gcd</a>(a,b,c);
<a name="l00038"></a>00038   <a class="code" href="source_2arith_2arithmetique_8h.html#ac633e4bcd9ed1d8412c67cda6d8ddb11">value_division</a>(*c, tmp, *c);
<a name="l00039"></a>00039   <a class="code" href="source_2arith_2arithmetique_8h.html#ab9b282921e85a0527d462d331533d619">value_clear</a>(tmp);
<a name="l00040"></a>00040 }
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 <span class="comment">/*</span>
<a name="l00043"></a>00043 <span class="comment"> * Return the lcm of &apos;i&apos; and &apos;j&apos; </span>
<a name="l00044"></a>00044 <span class="comment"> */</span> 
<a name="l00045"></a><a class="code" href="Matop_8h.html#a13dc27a49cfaf5367846f015b76c2840">00045</a> Value *<a class="code" href="Matop_8c.html#a13dc27a49cfaf5367846f015b76c2840">Lcm</a> (Value i, Value j)
<a name="l00046"></a>00046 {
<a name="l00047"></a>00047   Value *tmp;
<a name="l00048"></a>00048   
<a name="l00049"></a>00049   tmp = (Value *) malloc (<span class="keyword">sizeof</span>(Value));
<a name="l00050"></a>00050   <a class="code" href="source_2arith_2arithmetique_8h.html#af71a2ca0294a19cff0cdcbdcc052ee27">value_init</a>(*tmp);
<a name="l00051"></a>00051   <a class="code" href="Matop_8c.html#a69ef60460903eaa2378b40e13181e565">Lcm3</a>(i, j, tmp);
<a name="l00052"></a>00052   <span class="keywordflow">return</span> tmp;
<a name="l00053"></a>00053 } <span class="comment">/* Lcm */</span>
<a name="l00054"></a>00054 
<a name="l00055"></a>00055 <span class="comment">/* </span>
<a name="l00056"></a>00056 <span class="comment"> * Return an identity matrix of size &apos;size&apos;. </span>
<a name="l00057"></a>00057 <span class="comment"> */</span>
<a name="l00058"></a><a class="code" href="Matop_8h.html#ac886b07103118bccddf1693e2bb9655f">00058</a> <a class="code" href="structmatrix.html">Matrix</a> *<a class="code" href="Matop_8c.html#ac886b07103118bccddf1693e2bb9655f">Identity</a>(<span class="keywordtype">unsigned</span> <a class="code" href="vector_8c.html#a439227feff9d7f55384e8780cfc2eb82">size</a>)
<a name="l00059"></a>00059 {
<a name="l00060"></a>00060   <span class="keywordtype">unsigned</span> i;
<a name="l00061"></a>00061   <a class="code" href="structmatrix.html">Matrix</a> *A;
<a name="l00062"></a>00062   
<a name="l00063"></a>00063   A = <a class="code" href="matrix_8c.html#ac0b29e1d99a2823ad00b5f2157879d80">Matrix_Alloc</a>(size, size);
<a name="l00064"></a>00064   <span class="keywordflow">for</span> (i = 0; i &lt; size; i++)  
<a name="l00065"></a>00065     <a class="code" href="source_2arith_2arithmetique_8h.html#a8cc56567a4a29271559ac0fd5f6c5bfa">value_set_si</a>(A-&gt;<a class="code" href="structmatrix.html#a2c6d840d8d911ae95c2ae4fc96f4b5ba">p</a>[i][i], 1);
<a name="l00066"></a>00066   <span class="keywordflow">return</span> A;
<a name="l00067"></a>00067 } <span class="comment">/* Identity */</span>
<a name="l00068"></a>00068 
<a name="l00069"></a>00069 <span class="comment">/*</span>
<a name="l00070"></a>00070 <span class="comment"> * Exchange the rows &apos;Row1&apos; and &apos;Row2&apos; of the matrix &apos;M&apos;</span>
<a name="l00071"></a>00071 <span class="comment"> */</span>
<a name="l00072"></a><a class="code" href="Matop_8h.html#acf8ce28d22ae1fabdf97ac6c4e86341a">00072</a> <span class="keywordtype">void</span> <a class="code" href="Matop_8c.html#acf8ce28d22ae1fabdf97ac6c4e86341a">ExchangeRows</a>(<a class="code" href="structmatrix.html">Matrix</a> *M, <span class="keywordtype">int</span> Row1, <span class="keywordtype">int</span> Row2) {
<a name="l00073"></a>00073   
<a name="l00074"></a>00074   <span class="keywordtype">int</span> i;
<a name="l00075"></a>00075   Value temp;
<a name="l00076"></a>00076   
<a name="l00077"></a>00077   <a class="code" href="source_2arith_2arithmetique_8h.html#af71a2ca0294a19cff0cdcbdcc052ee27">value_init</a>(temp);
<a name="l00078"></a>00078   <span class="keywordflow">for</span> (i = 0; i &lt; (int)M-&gt;<a class="code" href="structmatrix.html#a68858fd3b57684ef38bdfce13c65d182">NbColumns</a>;  i++) {
<a name="l00079"></a>00079     <a class="code" href="source_2arith_2arithmetique_8h.html#a864613888dc46f15679aa4f63e468f89">value_assign</a>(temp,M-&gt;<a class="code" href="structmatrix.html#a2c6d840d8d911ae95c2ae4fc96f4b5ba">p</a>[Row1][i]);
<a name="l00080"></a>00080     <a class="code" href="source_2arith_2arithmetique_8h.html#a864613888dc46f15679aa4f63e468f89">value_assign</a>(M-&gt;<a class="code" href="structmatrix.html#a2c6d840d8d911ae95c2ae4fc96f4b5ba">p</a>[Row1][i],M-&gt;<a class="code" href="structmatrix.html#a2c6d840d8d911ae95c2ae4fc96f4b5ba">p</a>[Row2][i]);
<a name="l00081"></a>00081     <a class="code" href="source_2arith_2arithmetique_8h.html#a864613888dc46f15679aa4f63e468f89">value_assign</a>(M-&gt;<a class="code" href="structmatrix.html#a2c6d840d8d911ae95c2ae4fc96f4b5ba">p</a>[Row2][i],temp);
<a name="l00082"></a>00082   }  
<a name="l00083"></a>00083   <a class="code" href="source_2arith_2arithmetique_8h.html#ab9b282921e85a0527d462d331533d619">value_clear</a>(temp);
<a name="l00084"></a>00084   return ;
<a name="l00085"></a>00085 } <span class="comment">/* ExchangeRows */</span>
<a name="l00086"></a>00086 
<a name="l00087"></a>00087 <span class="comment">/*</span>
<a name="l00088"></a>00088 <span class="comment"> * Exchange the columns &apos;Column1&apos; and &apos;Column2&apos; of the matrix &apos;M&apos;</span>
<a name="l00089"></a>00089 <span class="comment"> */</span>
<a name="l00090"></a><a class="code" href="Matop_8h.html#af9321ba930c53a16bb88667689268d5d">00090</a> <span class="keywordtype">void</span> <a class="code" href="Matop_8c.html#af9321ba930c53a16bb88667689268d5d">ExchangeColumns</a>(<a class="code" href="structmatrix.html">Matrix</a> *M, <span class="keywordtype">int</span> Column1, <span class="keywordtype">int</span> Column2) {
<a name="l00091"></a>00091   
<a name="l00092"></a>00092   <span class="keywordtype">int</span> i;
<a name="l00093"></a>00093   
<a name="l00094"></a>00094   <span class="keywordflow">for</span> (i = 0; i &lt; M-&gt;<a class="code" href="structmatrix.html#a16ad614d15c6e81c0041e877b623c72d">NbRows</a>; i++)
<a name="l00095"></a>00095     <a class="code" href="source_2arith_2arithmetique_8h.html#a2ebe6e1a78900fb98fe3fa619cb4a4b7">value_swap</a>(M-&gt;<a class="code" href="structmatrix.html#a2c6d840d8d911ae95c2ae4fc96f4b5ba">p</a>[i][Column1],M-&gt;<a class="code" href="structmatrix.html#a2c6d840d8d911ae95c2ae4fc96f4b5ba">p</a>[i][Column2]);
<a name="l00096"></a>00096 
<a name="l00097"></a>00097   <span class="keywordflow">return</span>;
<a name="l00098"></a>00098 } <span class="comment">/* ExchangeColumns */</span>
<a name="l00099"></a>00099 
<a name="l00100"></a>00100 <span class="comment">/* </span>
<a name="l00101"></a>00101 <span class="comment"> * Return the Transpose of a matrix &apos;A&apos; </span>
<a name="l00102"></a>00102 <span class="comment"> */</span>
<a name="l00103"></a><a class="code" href="Matop_8h.html#ab635a9108899776e30e1de03fe183915">00103</a> <a class="code" href="structmatrix.html">Matrix</a> *<a class="code" href="Matop_8c.html#ab635a9108899776e30e1de03fe183915">Transpose</a> (<a class="code" href="structmatrix.html">Matrix</a> *A) {
<a name="l00104"></a>00104   
<a name="l00105"></a>00105   <span class="keywordtype">int</span> i,j;
<a name="l00106"></a>00106   <a class="code" href="structmatrix.html">Matrix</a> *<a class="code" href="NormalForms_8c.html#aa89e5160f2aae2765d3255b844946673">transpose</a>;
<a name="l00107"></a>00107   
<a name="l00108"></a>00108   transpose = <a class="code" href="matrix_8c.html#ac0b29e1d99a2823ad00b5f2157879d80">Matrix_Alloc</a> (A-&gt;<a class="code" href="structmatrix.html#a68858fd3b57684ef38bdfce13c65d182">NbColumns</a>, A-&gt;<a class="code" href="structmatrix.html#a16ad614d15c6e81c0041e877b623c72d">NbRows</a>);
<a name="l00109"></a>00109   <span class="keywordflow">for</span> (i = 0; i &lt; (int)A-&gt;<a class="code" href="structmatrix.html#a16ad614d15c6e81c0041e877b623c72d">NbRows</a>; i++)
<a name="l00110"></a>00110     <span class="keywordflow">for</span> (j = 0; j &lt; (int)A-&gt;<a class="code" href="structmatrix.html#a68858fd3b57684ef38bdfce13c65d182">NbColumns</a>; j++)
<a name="l00111"></a>00111       <a class="code" href="source_2arith_2arithmetique_8h.html#a864613888dc46f15679aa4f63e468f89">value_assign</a>(transpose-&gt;<a class="code" href="structmatrix.html#a2c6d840d8d911ae95c2ae4fc96f4b5ba">p</a>[j][i],A-&gt;<a class="code" href="structmatrix.html#a2c6d840d8d911ae95c2ae4fc96f4b5ba">p</a>[i][j]);
<a name="l00112"></a>00112   <span class="keywordflow">return</span> transpose;
<a name="l00113"></a>00113 } <span class="comment">/* Transpose */</span>
<a name="l00114"></a>00114 
<a name="l00115"></a>00115 <span class="comment">/*</span>
<a name="l00116"></a>00116 <span class="comment"> * Return a copy of the contents of a matrix &apos;Src&apos;.</span>
<a name="l00117"></a>00117 <span class="comment"> */</span>
<a name="l00118"></a><a class="code" href="Matop_8h.html#a9d027e9fc6b85e6fa37fc284bf1b5e06">00118</a> <a class="code" href="structmatrix.html">Matrix</a> *<a class="code" href="Matop_8c.html#a9d027e9fc6b85e6fa37fc284bf1b5e06">Matrix_Copy</a>(<a class="code" href="structmatrix.html">Matrix</a> <span class="keyword">const</span> *Src )
<a name="l00119"></a>00119 {
<a name="l00120"></a>00120   <a class="code" href="structmatrix.html">Matrix</a> *Dst;
<a name="l00121"></a>00121   <span class="keywordtype">unsigned</span> i, j;
<a name="l00122"></a>00122   
<a name="l00123"></a>00123   Dst = <a class="code" href="matrix_8c.html#ac0b29e1d99a2823ad00b5f2157879d80">Matrix_Alloc</a>(Src-&gt;<a class="code" href="structmatrix.html#a16ad614d15c6e81c0041e877b623c72d">NbRows</a>, Src-&gt;<a class="code" href="structmatrix.html#a68858fd3b57684ef38bdfce13c65d182">NbColumns</a>);
<a name="l00124"></a>00124   
<a name="l00125"></a>00125   <span class="keywordflow">for</span> (i = 0; i &lt; Src-&gt;<a class="code" href="structmatrix.html#a16ad614d15c6e81c0041e877b623c72d">NbRows</a>; i++)
<a name="l00126"></a>00126     <span class="keywordflow">for</span> (j = 0; j &lt; Src-&gt;<a class="code" href="structmatrix.html#a68858fd3b57684ef38bdfce13c65d182">NbColumns</a>; j++)
<a name="l00127"></a>00127       <a class="code" href="source_2arith_2arithmetique_8h.html#a864613888dc46f15679aa4f63e468f89">value_assign</a>(Dst-&gt;<a class="code" href="structmatrix.html#a2c6d840d8d911ae95c2ae4fc96f4b5ba">p</a>[i][j],Src-&gt;<a class="code" href="structmatrix.html#a2c6d840d8d911ae95c2ae4fc96f4b5ba">p</a>[i][j]);
<a name="l00128"></a>00128   <span class="keywordflow">return</span> Dst;
<a name="l00129"></a>00129 } <span class="comment">/* Matrix_copy */</span>
<a name="l00130"></a>00130 
<a name="l00131"></a>00131 <span class="comment">/* </span>
<a name="l00132"></a>00132 <span class="comment"> * Test if the input matrix is integral or not. </span>
<a name="l00133"></a>00133 <span class="comment"> */</span>
<a name="l00134"></a><a class="code" href="Matop_8h.html#ab11e2b3f499da1c15918d52e690cfbd1">00134</a> <a class="code" href="types_8h.html#a39db6982619d623273fad8a383489309">Bool</a> <a class="code" href="Matop_8c.html#ab11e2b3f499da1c15918d52e690cfbd1">isIntegral</a> (<a class="code" href="structmatrix.html">Matrix</a> *A) {
<a name="l00135"></a>00135   
<a name="l00136"></a>00136   <span class="keywordtype">unsigned</span> i, j;
<a name="l00137"></a>00137   Value divisor, tmp;
<a name="l00138"></a>00138   
<a name="l00139"></a>00139   <a class="code" href="source_2arith_2arithmetique_8h.html#af71a2ca0294a19cff0cdcbdcc052ee27">value_init</a>(divisor); <a class="code" href="source_2arith_2arithmetique_8h.html#af71a2ca0294a19cff0cdcbdcc052ee27">value_init</a>(tmp);
<a name="l00140"></a>00140   <a class="code" href="source_2arith_2arithmetique_8h.html#a864613888dc46f15679aa4f63e468f89">value_assign</a>(divisor,A-&gt;<a class="code" href="structmatrix.html#a2c6d840d8d911ae95c2ae4fc96f4b5ba">p</a>[A-&gt;<a class="code" href="structmatrix.html#a16ad614d15c6e81c0041e877b623c72d">NbRows</a>-1][A-&gt;<a class="code" href="structmatrix.html#a68858fd3b57684ef38bdfce13c65d182">NbColumns</a>-1]);
<a name="l00141"></a>00141 
<a name="l00142"></a>00142   <span class="keywordflow">for</span> (i = 0; i &lt; A-&gt;<a class="code" href="structmatrix.html#a16ad614d15c6e81c0041e877b623c72d">NbRows</a> ; i++)
<a name="l00143"></a>00143     <span class="keywordflow">for</span> (j = 0; j &lt; A-&gt;<a class="code" href="structmatrix.html#a68858fd3b57684ef38bdfce13c65d182">NbColumns</a> ; j++) {
<a name="l00144"></a>00144       <a class="code" href="source_2arith_2arithmetique_8h.html#ae77f928488d756f77270649775dbdc1d">value_modulus</a>(tmp,A-&gt;<a class="code" href="structmatrix.html#a2c6d840d8d911ae95c2ae4fc96f4b5ba">p</a>[i][j],divisor);
<a name="l00145"></a>00145       <span class="keywordflow">if</span> (<a class="code" href="source_2arith_2arithmetique_8h.html#a47d32925340d2dc99ef2d4215080a60d">value_notzero_p</a>(tmp)) {
<a name="l00146"></a>00146         <a class="code" href="source_2arith_2arithmetique_8h.html#ab9b282921e85a0527d462d331533d619">value_clear</a>(divisor); <a class="code" href="source_2arith_2arithmetique_8h.html#ab9b282921e85a0527d462d331533d619">value_clear</a>(tmp);
<a name="l00147"></a>00147           <span class="keywordflow">return</span> <a class="code" href="types_8h.html#a39db6982619d623273fad8a383489309af9d46b7804d93a4fcde88489a1b68c24">False</a>;  
<a name="l00148"></a>00148       }   
<a name="l00149"></a>00149     }
<a name="l00150"></a>00150   <a class="code" href="source_2arith_2arithmetique_8h.html#ab9b282921e85a0527d462d331533d619">value_clear</a>(divisor); <a class="code" href="source_2arith_2arithmetique_8h.html#ab9b282921e85a0527d462d331533d619">value_clear</a>(tmp);
<a name="l00151"></a>00151   <span class="keywordflow">return</span> <a class="code" href="types_8h.html#a39db6982619d623273fad8a383489309a6d32c34708a0a3507c4bdb89219d650b">True</a> ;
<a name="l00152"></a>00152 } <span class="comment">/* isIntegral */</span>
<a name="l00153"></a>00153 
<a name="l00154"></a>00154 <span class="comment">/*</span>
<a name="l00155"></a>00155 <span class="comment"> * Check if the matrix &apos;A&apos; is in Hermite normal form or not. </span>
<a name="l00156"></a>00156 <span class="comment"> */</span>
<a name="l00157"></a><a class="code" href="Matop_8h.html#a3f47c6fa59a6178c86d3990bb25af47b">00157</a> <a class="code" href="types_8h.html#a39db6982619d623273fad8a383489309">Bool</a> <a class="code" href="Matop_8c.html#a3f47c6fa59a6178c86d3990bb25af47b">isinHnf</a>(<a class="code" href="structmatrix.html">Matrix</a> *A) {
<a name="l00158"></a>00158  
<a name="l00159"></a>00159   <a class="code" href="structmatrix.html">Matrix</a> *temp ;
<a name="l00160"></a>00160   <span class="keywordtype">unsigned</span> i, j ;
<a name="l00161"></a>00161   Value rem;
<a name="l00162"></a>00162   
<a name="l00163"></a>00163   <a class="code" href="source_2arith_2arithmetique_8h.html#af71a2ca0294a19cff0cdcbdcc052ee27">value_init</a>(rem); 
<a name="l00164"></a>00164   temp = <a class="code" href="Lattice_8c.html#a00c3710631cd7f82d65329751095e78b">Homogenise</a>(A,<a class="code" href="types_8h.html#a39db6982619d623273fad8a383489309a6d32c34708a0a3507c4bdb89219d650b">True</a>) ;
<a name="l00165"></a>00165   <span class="keywordflow">for</span> (i = 0; i &lt; temp-&gt;<a class="code" href="structmatrix.html#a16ad614d15c6e81c0041e877b623c72d">NbRows</a>; i++) {
<a name="l00166"></a>00166     <a class="code" href="source_2arith_2arithmetique_8h.html#a864613888dc46f15679aa4f63e468f89">value_assign</a>(rem,temp-&gt;<a class="code" href="structmatrix.html#a2c6d840d8d911ae95c2ae4fc96f4b5ba">p</a>[i][i]);
<a name="l00167"></a>00167     <span class="keywordflow">for</span> (j = 0; j &lt; i ; j++)
<a name="l00168"></a>00168       <span class="keywordflow">if</span> (<a class="code" href="source_2arith_2arithmetique_8h.html#aeee525b427bd616a24b5b9feb9a9f02e">value_ge</a>(temp-&gt;<a class="code" href="structmatrix.html#a2c6d840d8d911ae95c2ae4fc96f4b5ba">p</a>[i][j],rem)) {
<a name="l00169"></a>00169         <a class="code" href="matrix_8c.html#afcb312b7c12a6997cd66964ecc34e1a6">Matrix_Free</a>(temp);
<a name="l00170"></a>00170         <a class="code" href="source_2arith_2arithmetique_8h.html#ab9b282921e85a0527d462d331533d619">value_clear</a>(rem);
<a name="l00171"></a>00171         <span class="keywordflow">return</span> <a class="code" href="types_8h.html#a39db6982619d623273fad8a383489309af9d46b7804d93a4fcde88489a1b68c24">False</a> ;
<a name="l00172"></a>00172       }
<a name="l00173"></a>00173     <span class="keywordflow">for</span> (j = i+1; j &lt; temp-&gt;<a class="code" href="structmatrix.html#a68858fd3b57684ef38bdfce13c65d182">NbColumns</a> ; j++)
<a name="l00174"></a>00174       <span class="keywordflow">if</span> (<a class="code" href="source_2arith_2arithmetique_8h.html#a47d32925340d2dc99ef2d4215080a60d">value_notzero_p</a>(temp-&gt;<a class="code" href="structmatrix.html#a2c6d840d8d911ae95c2ae4fc96f4b5ba">p</a>[i][j])) {
<a name="l00175"></a>00175         <a class="code" href="matrix_8c.html#afcb312b7c12a6997cd66964ecc34e1a6">Matrix_Free</a>(temp);
<a name="l00176"></a>00176         <a class="code" href="source_2arith_2arithmetique_8h.html#ab9b282921e85a0527d462d331533d619">value_clear</a>(rem);
<a name="l00177"></a>00177         <span class="keywordflow">return</span> <a class="code" href="types_8h.html#a39db6982619d623273fad8a383489309af9d46b7804d93a4fcde88489a1b68c24">False</a> ;
<a name="l00178"></a>00178       }
<a name="l00179"></a>00179   }
<a name="l00180"></a>00180   <a class="code" href="matrix_8c.html#afcb312b7c12a6997cd66964ecc34e1a6">Matrix_Free</a>(temp);
<a name="l00181"></a>00181   <a class="code" href="source_2arith_2arithmetique_8h.html#ab9b282921e85a0527d462d331533d619">value_clear</a>(rem);
<a name="l00182"></a>00182   <span class="keywordflow">return</span> <a class="code" href="types_8h.html#a39db6982619d623273fad8a383489309a6d32c34708a0a3507c4bdb89219d650b">True</a> ;
<a name="l00183"></a>00183 } <span class="comment">/* isinHnf */</span>
<a name="l00184"></a>00184 
<a name="l00185"></a>00185 <span class="comment">/*</span>
<a name="l00186"></a>00186 <span class="comment"> * Remove the row &apos;Rownumber&apos; and place it at the end of the matrix &apos;X&apos;  </span>
<a name="l00187"></a>00187 <span class="comment"> */</span> 
<a name="l00188"></a><a class="code" href="Matop_8h.html#a437f63cf9b5f8caea2b5dd4b27f9a28a">00188</a> <span class="keywordtype">void</span> <a class="code" href="Matop_8c.html#a437f63cf9b5f8caea2b5dd4b27f9a28a">PutRowLast</a> (<a class="code" href="structmatrix.html">Matrix</a> *X, <span class="keywordtype">int</span> Rownumber) {
<a name="l00189"></a>00189   
<a name="l00190"></a>00190   <span class="keywordtype">int</span> i, j ;
<a name="l00191"></a>00191   Value temp;
<a name="l00192"></a>00192  
<a name="l00193"></a>00193   <span class="keywordflow">if</span> (Rownumber == X-&gt;<a class="code" href="structmatrix.html#a16ad614d15c6e81c0041e877b623c72d">NbRows</a>-1)
<a name="l00194"></a>00194     <span class="keywordflow">return</span>;
<a name="l00195"></a>00195   
<a name="l00196"></a>00196   <a class="code" href="source_2arith_2arithmetique_8h.html#af71a2ca0294a19cff0cdcbdcc052ee27">value_init</a>(temp);
<a name="l00197"></a>00197   <span class="keywordflow">for</span> (j = 0; j &lt; X-&gt;<a class="code" href="structmatrix.html#a68858fd3b57684ef38bdfce13c65d182">NbColumns</a>; j++) {
<a name="l00198"></a>00198     <a class="code" href="source_2arith_2arithmetique_8h.html#a864613888dc46f15679aa4f63e468f89">value_assign</a>(temp,X-&gt;<a class="code" href="structmatrix.html#a2c6d840d8d911ae95c2ae4fc96f4b5ba">p</a>[Rownumber][j]);
<a name="l00199"></a>00199     <span class="keywordflow">for</span> (i = Rownumber; i &lt; X-&gt;<a class="code" href="structmatrix.html#a16ad614d15c6e81c0041e877b623c72d">NbRows</a>-1; i++)
<a name="l00200"></a>00200       <a class="code" href="source_2arith_2arithmetique_8h.html#a864613888dc46f15679aa4f63e468f89">value_assign</a>(X-&gt;<a class="code" href="structmatrix.html#a2c6d840d8d911ae95c2ae4fc96f4b5ba">p</a>[i][j],X-&gt;<a class="code" href="structmatrix.html#a2c6d840d8d911ae95c2ae4fc96f4b5ba">p</a>[i+1][j]);
<a name="l00201"></a>00201     <a class="code" href="source_2arith_2arithmetique_8h.html#a864613888dc46f15679aa4f63e468f89">value_assign</a>(X-&gt;<a class="code" href="structmatrix.html#a2c6d840d8d911ae95c2ae4fc96f4b5ba">p</a>[i][j],temp);
<a name="l00202"></a>00202   }
<a name="l00203"></a>00203   <a class="code" href="source_2arith_2arithmetique_8h.html#ab9b282921e85a0527d462d331533d619">value_clear</a>(temp);
<a name="l00204"></a>00204   <span class="keywordflow">return</span>;
<a name="l00205"></a>00205 } <span class="comment">/* PutRowLast */</span>
<a name="l00206"></a>00206 
<a name="l00207"></a>00207 <span class="comment">/* </span>
<a name="l00208"></a>00208 <span class="comment"> * Remove the row &apos;Rownumber&apos; and place it at the begining of the matrix &apos;X&apos; </span>
<a name="l00209"></a>00209 <span class="comment"> */</span> 
<a name="l00210"></a><a class="code" href="Matop_8h.html#ab6ddbe687809022ebaf4ff691adbb48d">00210</a> <span class="keywordtype">void</span> <a class="code" href="Matop_8c.html#ab6ddbe687809022ebaf4ff691adbb48d">PutRowFirst</a>(<a class="code" href="structmatrix.html">Matrix</a> *X, <span class="keywordtype">int</span> Rownumber) {
<a name="l00211"></a>00211   
<a name="l00212"></a>00212   <span class="keywordtype">int</span> i, j ;
<a name="l00213"></a>00213   Value temp;
<a name="l00214"></a>00214 
<a name="l00215"></a>00215   <a class="code" href="source_2arith_2arithmetique_8h.html#af71a2ca0294a19cff0cdcbdcc052ee27">value_init</a>(temp);
<a name="l00216"></a>00216   <span class="keywordflow">for</span> (j = 0; j &lt; X-&gt;<a class="code" href="structmatrix.html#a68858fd3b57684ef38bdfce13c65d182">NbColumns</a>; j++) {
<a name="l00217"></a>00217     <a class="code" href="source_2arith_2arithmetique_8h.html#a864613888dc46f15679aa4f63e468f89">value_assign</a>(temp,X-&gt;<a class="code" href="structmatrix.html#a2c6d840d8d911ae95c2ae4fc96f4b5ba">p</a>[Rownumber][j]);
<a name="l00218"></a>00218     <span class="keywordflow">for</span> (i = Rownumber; i &gt; 0; i--)
<a name="l00219"></a>00219       <a class="code" href="source_2arith_2arithmetique_8h.html#a864613888dc46f15679aa4f63e468f89">value_assign</a>(X-&gt;<a class="code" href="structmatrix.html#a2c6d840d8d911ae95c2ae4fc96f4b5ba">p</a>[i][j],X-&gt;<a class="code" href="structmatrix.html#a2c6d840d8d911ae95c2ae4fc96f4b5ba">p</a>[i-1][j]);
<a name="l00220"></a>00220     <a class="code" href="source_2arith_2arithmetique_8h.html#a864613888dc46f15679aa4f63e468f89">value_assign</a>(X-&gt;<a class="code" href="structmatrix.html#a2c6d840d8d911ae95c2ae4fc96f4b5ba">p</a>[i][j],temp);
<a name="l00221"></a>00221   }
<a name="l00222"></a>00222   <a class="code" href="source_2arith_2arithmetique_8h.html#ab9b282921e85a0527d462d331533d619">value_clear</a>(temp);
<a name="l00223"></a>00223   <span class="keywordflow">return</span>;
<a name="l00224"></a>00224 } <span class="comment">/* PutRowFirst */</span>
<a name="l00225"></a>00225 
<a name="l00226"></a>00226 <span class="comment">/*</span>
<a name="l00227"></a>00227 <span class="comment"> * Remove the column &apos;Columnnumber&apos; and place it at the begining of the matrix</span>
<a name="l00228"></a>00228 <span class="comment"> * &apos;X&apos;</span>
<a name="l00229"></a>00229 <span class="comment"> */</span>
<a name="l00230"></a><a class="code" href="Matop_8h.html#abff6804a65715b1def03cf02c07d138c">00230</a> <span class="keywordtype">void</span> <a class="code" href="Matop_8c.html#abff6804a65715b1def03cf02c07d138c">PutColumnFirst</a> (<a class="code" href="structmatrix.html">Matrix</a> *X, <span class="keywordtype">int</span> Columnnumber) {
<a name="l00231"></a>00231   
<a name="l00232"></a>00232   <span class="keywordtype">int</span> i, j ;
<a name="l00233"></a>00233   Value temp;
<a name="l00234"></a>00234 
<a name="l00235"></a>00235   <a class="code" href="source_2arith_2arithmetique_8h.html#af71a2ca0294a19cff0cdcbdcc052ee27">value_init</a>(temp);
<a name="l00236"></a>00236   <span class="keywordflow">for</span> (i = 0; i &lt; X-&gt;<a class="code" href="structmatrix.html#a16ad614d15c6e81c0041e877b623c72d">NbRows</a>; i ++) {
<a name="l00237"></a>00237     <a class="code" href="source_2arith_2arithmetique_8h.html#a864613888dc46f15679aa4f63e468f89">value_assign</a>(temp,X-&gt;<a class="code" href="structmatrix.html#a2c6d840d8d911ae95c2ae4fc96f4b5ba">p</a>[i][Columnnumber]);
<a name="l00238"></a>00238     <span class="keywordflow">for</span> (j = Columnnumber; j &gt; 0; j --)
<a name="l00239"></a>00239       <a class="code" href="source_2arith_2arithmetique_8h.html#a864613888dc46f15679aa4f63e468f89">value_assign</a>(X-&gt;<a class="code" href="structmatrix.html#a2c6d840d8d911ae95c2ae4fc96f4b5ba">p</a>[i][j],X-&gt;<a class="code" href="structmatrix.html#a2c6d840d8d911ae95c2ae4fc96f4b5ba">p</a>[i][j-1]);
<a name="l00240"></a>00240     <a class="code" href="source_2arith_2arithmetique_8h.html#a864613888dc46f15679aa4f63e468f89">value_assign</a>(X-&gt;<a class="code" href="structmatrix.html#a2c6d840d8d911ae95c2ae4fc96f4b5ba">p</a>[i][0],temp);
<a name="l00241"></a>00241   }
<a name="l00242"></a>00242   <a class="code" href="source_2arith_2arithmetique_8h.html#ab9b282921e85a0527d462d331533d619">value_clear</a>(temp);
<a name="l00243"></a>00243   return ;
<a name="l00244"></a>00244 } <span class="comment">/* PutColumnFirst */</span>
<a name="l00245"></a>00245 
<a name="l00246"></a>00246 <span class="comment">/*</span>
<a name="l00247"></a>00247 <span class="comment"> * Remove the column &apos;Columnnumber&apos; and place it at the end of the matrix &apos;X&apos;</span>
<a name="l00248"></a>00248 <span class="comment"> */</span>
<a name="l00249"></a><a class="code" href="Matop_8h.html#a5912c5c3befc11a92877a93969f359f6">00249</a> <span class="keywordtype">void</span> <a class="code" href="Matop_8c.html#a5912c5c3befc11a92877a93969f359f6">PutColumnLast</a> (<a class="code" href="structmatrix.html">Matrix</a> *X, <span class="keywordtype">int</span> Columnnumber) {
<a name="l00250"></a>00250   
<a name="l00251"></a>00251   <span class="keywordtype">int</span> i, j ;
<a name="l00252"></a>00252   Value temp;
<a name="l00253"></a>00253 
<a name="l00254"></a>00254   <a class="code" href="source_2arith_2arithmetique_8h.html#af71a2ca0294a19cff0cdcbdcc052ee27">value_init</a>(temp);
<a name="l00255"></a>00255   <span class="keywordflow">for</span> (i = 0; i &lt; X-&gt;<a class="code" href="structmatrix.html#a16ad614d15c6e81c0041e877b623c72d">NbRows</a>; i++) {
<a name="l00256"></a>00256     <a class="code" href="source_2arith_2arithmetique_8h.html#a864613888dc46f15679aa4f63e468f89">value_assign</a>(temp,X-&gt;<a class="code" href="structmatrix.html#a2c6d840d8d911ae95c2ae4fc96f4b5ba">p</a>[i][Columnnumber]);
<a name="l00257"></a>00257     <span class="keywordflow">for</span> (j = Columnnumber; j &lt; X-&gt;<a class="code" href="structmatrix.html#a68858fd3b57684ef38bdfce13c65d182">NbColumns</a>-1; j++)
<a name="l00258"></a>00258       <a class="code" href="source_2arith_2arithmetique_8h.html#a864613888dc46f15679aa4f63e468f89">value_assign</a>(X-&gt;<a class="code" href="structmatrix.html#a2c6d840d8d911ae95c2ae4fc96f4b5ba">p</a>[i][j],X-&gt;<a class="code" href="structmatrix.html#a2c6d840d8d911ae95c2ae4fc96f4b5ba">p</a>[i][j+1]);
<a name="l00259"></a>00259     <a class="code" href="source_2arith_2arithmetique_8h.html#a864613888dc46f15679aa4f63e468f89">value_assign</a>(X-&gt;<a class="code" href="structmatrix.html#a2c6d840d8d911ae95c2ae4fc96f4b5ba">p</a>[i][X-&gt;<a class="code" href="structmatrix.html#a68858fd3b57684ef38bdfce13c65d182">NbColumns</a>-1],temp);
<a name="l00260"></a>00260   }
<a name="l00261"></a>00261   <a class="code" href="source_2arith_2arithmetique_8h.html#ab9b282921e85a0527d462d331533d619">value_clear</a>(temp);
<a name="l00262"></a>00262   return ;
<a name="l00263"></a>00263 } <span class="comment">/* PutColumnLast */</span>
<a name="l00264"></a>00264 
<a name="l00265"></a>00265 <span class="comment">/*</span>
<a name="l00266"></a>00266 <span class="comment"> * Add a row of zeros at the end of the matrix &apos;M&apos; and return the new matrix </span>
<a name="l00267"></a>00267 <span class="comment"> */</span>
<a name="l00268"></a><a class="code" href="Matop_8h.html#a76461087aa1a40441a3dc174e8359b97">00268</a> <a class="code" href="structmatrix.html">Matrix</a> *<a class="code" href="Matop_8c.html#a76461087aa1a40441a3dc174e8359b97">AddANullRow</a> (<a class="code" href="structmatrix.html">Matrix</a> *M) {
<a name="l00269"></a>00269   
<a name="l00270"></a>00270   <span class="keywordtype">int</span> i,j;
<a name="l00271"></a>00271   <a class="code" href="structmatrix.html">Matrix</a> *Result;
<a name="l00272"></a>00272   
<a name="l00273"></a>00273   Result = <a class="code" href="matrix_8c.html#ac0b29e1d99a2823ad00b5f2157879d80">Matrix_Alloc</a>(M-&gt;<a class="code" href="structmatrix.html#a16ad614d15c6e81c0041e877b623c72d">NbRows</a>+1,M-&gt;<a class="code" href="structmatrix.html#a68858fd3b57684ef38bdfce13c65d182">NbColumns</a>);
<a name="l00274"></a>00274   <span class="keywordflow">for</span> (i = 0;i &lt; M-&gt;<a class="code" href="structmatrix.html#a16ad614d15c6e81c0041e877b623c72d">NbRows</a>; i++)
<a name="l00275"></a>00275     <span class="keywordflow">for</span> (j = 0; j &lt; M-&gt;<a class="code" href="structmatrix.html#a68858fd3b57684ef38bdfce13c65d182">NbColumns</a> ; j++)
<a name="l00276"></a>00276       <a class="code" href="source_2arith_2arithmetique_8h.html#a864613888dc46f15679aa4f63e468f89">value_assign</a>(Result-&gt;<a class="code" href="structmatrix.html#a2c6d840d8d911ae95c2ae4fc96f4b5ba">p</a>[i][j],M-&gt;<a class="code" href="structmatrix.html#a2c6d840d8d911ae95c2ae4fc96f4b5ba">p</a>[i][j]);
<a name="l00277"></a>00277   <span class="keywordflow">for</span> (j = 0; j &lt; M-&gt;<a class="code" href="structmatrix.html#a68858fd3b57684ef38bdfce13c65d182">NbColumns</a>; j++)
<a name="l00278"></a>00278     <a class="code" href="source_2arith_2arithmetique_8h.html#a8cc56567a4a29271559ac0fd5f6c5bfa">value_set_si</a>(Result-&gt;<a class="code" href="structmatrix.html#a2c6d840d8d911ae95c2ae4fc96f4b5ba">p</a>[i][j],0);  
<a name="l00279"></a>00279   <span class="keywordflow">return</span> Result;
<a name="l00280"></a>00280 } <span class="comment">/* AddANullRow */</span>
<a name="l00281"></a>00281 
<a name="l00282"></a>00282 <span class="comment">/* </span>
<a name="l00283"></a>00283 <span class="comment"> * Add a column of zeros at the end of the matrix &apos;M&apos; and return the new </span>
<a name="l00284"></a>00284 <span class="comment"> * matrix</span>
<a name="l00285"></a>00285 <span class="comment"> */</span>   
<a name="l00286"></a><a class="code" href="Matop_8h.html#a7d43e9c44b8c49cd9a542102042ad72e">00286</a> <a class="code" href="structmatrix.html">Matrix</a> *<a class="code" href="Matop_8c.html#a7d43e9c44b8c49cd9a542102042ad72e">AddANullColumn</a>(<a class="code" href="structmatrix.html">Matrix</a> *M) {
<a name="l00287"></a>00287   
<a name="l00288"></a>00288   <span class="keywordtype">int</span> i,j;
<a name="l00289"></a>00289   <a class="code" href="structmatrix.html">Matrix</a> *Result;
<a name="l00290"></a>00290   
<a name="l00291"></a>00291   Result = <a class="code" href="matrix_8c.html#ac0b29e1d99a2823ad00b5f2157879d80">Matrix_Alloc</a>(M-&gt;<a class="code" href="structmatrix.html#a16ad614d15c6e81c0041e877b623c72d">NbRows</a>, M-&gt;<a class="code" href="structmatrix.html#a68858fd3b57684ef38bdfce13c65d182">NbColumns</a>+1);
<a name="l00292"></a>00292   <span class="keywordflow">for</span> (i = 0;i &lt; M-&gt;<a class="code" href="structmatrix.html#a16ad614d15c6e81c0041e877b623c72d">NbRows</a>; i++)
<a name="l00293"></a>00293     <span class="keywordflow">for</span> (j = 0; j &lt; M-&gt;<a class="code" href="structmatrix.html#a68858fd3b57684ef38bdfce13c65d182">NbColumns</a> ; j++)
<a name="l00294"></a>00294       <a class="code" href="source_2arith_2arithmetique_8h.html#a864613888dc46f15679aa4f63e468f89">value_assign</a>(Result-&gt;<a class="code" href="structmatrix.html#a2c6d840d8d911ae95c2ae4fc96f4b5ba">p</a>[i][j],M-&gt;<a class="code" href="structmatrix.html#a2c6d840d8d911ae95c2ae4fc96f4b5ba">p</a>[i][j]);
<a name="l00295"></a>00295   <span class="keywordflow">for</span> (i = 0; i &lt; M-&gt;<a class="code" href="structmatrix.html#a16ad614d15c6e81c0041e877b623c72d">NbRows</a>; i++)
<a name="l00296"></a>00296     <a class="code" href="source_2arith_2arithmetique_8h.html#a8cc56567a4a29271559ac0fd5f6c5bfa">value_set_si</a>(Result-&gt;<a class="code" href="structmatrix.html#a2c6d840d8d911ae95c2ae4fc96f4b5ba">p</a>[i][M-&gt;<a class="code" href="structmatrix.html#a68858fd3b57684ef38bdfce13c65d182">NbColumns</a>],0);
<a name="l00297"></a>00297   <span class="keywordflow">return</span> Result;
<a name="l00298"></a>00298 } <span class="comment">/* AddANullColumn */</span>
<a name="l00299"></a>00299 
<a name="l00300"></a>00300 <span class="comment">/*</span>
<a name="l00301"></a>00301 <span class="comment"> * Remove a row &apos;Rownumber&apos; from matrix &apos;M&apos; and return the new matrix.</span>
<a name="l00302"></a>00302 <span class="comment"> */</span>
<a name="l00303"></a><a class="code" href="Matop_8h.html#a4ef5342bc70d9c63714d1092a7668b03">00303</a> <a class="code" href="structmatrix.html">Matrix</a> *<a class="code" href="Matop_8c.html#a4ef5342bc70d9c63714d1092a7668b03">RemoveRow</a>(<a class="code" href="structmatrix.html">Matrix</a> *M, <span class="keywordtype">int</span> Rownumber) {
<a name="l00304"></a>00304   
<a name="l00305"></a>00305   <a class="code" href="structmatrix.html">Matrix</a> *Result;
<a name="l00306"></a>00306   <span class="keywordtype">int</span> i;
<a name="l00307"></a>00307   
<a name="l00308"></a>00308   Result = <a class="code" href="matrix_8c.html#ac0b29e1d99a2823ad00b5f2157879d80">Matrix_Alloc</a>(M-&gt;<a class="code" href="structmatrix.html#a16ad614d15c6e81c0041e877b623c72d">NbRows</a>-1, M-&gt;<a class="code" href="structmatrix.html#a68858fd3b57684ef38bdfce13c65d182">NbColumns</a>);
<a name="l00309"></a>00309   
<a name="l00310"></a>00310   <span class="keywordflow">for</span> (i = 0; i &lt; Rownumber; i++)
<a name="l00311"></a>00311     <a class="code" href="vector_8c.html#ab6eca9ad03a2f4a60dd79182289e0e0b">Vector_Copy</a>(M-&gt;<a class="code" href="structmatrix.html#a2c6d840d8d911ae95c2ae4fc96f4b5ba">p</a>[i], Result-&gt;<a class="code" href="structmatrix.html#a2c6d840d8d911ae95c2ae4fc96f4b5ba">p</a>[i], M-&gt;<a class="code" href="structmatrix.html#a68858fd3b57684ef38bdfce13c65d182">NbColumns</a>);
<a name="l00312"></a>00312   <span class="keywordflow">for</span> ( ; i &lt; Result-&gt;<a class="code" href="structmatrix.html#a16ad614d15c6e81c0041e877b623c72d">NbRows</a>; i++)
<a name="l00313"></a>00313     <a class="code" href="vector_8c.html#ab6eca9ad03a2f4a60dd79182289e0e0b">Vector_Copy</a>(M-&gt;<a class="code" href="structmatrix.html#a2c6d840d8d911ae95c2ae4fc96f4b5ba">p</a>[i+1], Result-&gt;<a class="code" href="structmatrix.html#a2c6d840d8d911ae95c2ae4fc96f4b5ba">p</a>[i], M-&gt;<a class="code" href="structmatrix.html#a68858fd3b57684ef38bdfce13c65d182">NbColumns</a>);
<a name="l00314"></a>00314 
<a name="l00315"></a>00315   <span class="keywordflow">return</span> Result;
<a name="l00316"></a>00316 } <span class="comment">/* RemoveRow */</span>
<a name="l00317"></a>00317 
<a name="l00318"></a>00318 <span class="comment">/*</span>
<a name="l00319"></a>00319 <span class="comment"> * Remove NumColumns columns starting at column number &apos;FirstColumnnumber&apos; from matrix &apos;M&apos;</span>
<a name="l00320"></a>00320 <span class="comment"> * and return the new matrix.</span>
<a name="l00321"></a>00321 <span class="comment"> */</span>
<a name="l00322"></a><a class="code" href="Matop_8h.html#a4b8fff8126ca3b066999fd338c0ba023">00322</a> <a class="code" href="structmatrix.html">Matrix</a> *<a class="code" href="Matop_8c.html#a4b8fff8126ca3b066999fd338c0ba023">RemoveNColumns</a> (<a class="code" href="structmatrix.html">Matrix</a> *M, <span class="keywordtype">int</span> FirstColumnnumber, <span class="keywordtype">int</span> NumColumns) {
<a name="l00323"></a>00323   
<a name="l00324"></a>00324   <a class="code" href="structmatrix.html">Matrix</a> *Result;
<a name="l00325"></a>00325   <span class="keywordtype">int</span> i;
<a name="l00326"></a>00326   
<a name="l00327"></a>00327   Result = <a class="code" href="matrix_8c.html#ac0b29e1d99a2823ad00b5f2157879d80">Matrix_Alloc</a> (M-&gt;<a class="code" href="structmatrix.html#a16ad614d15c6e81c0041e877b623c72d">NbRows</a>, M-&gt;<a class="code" href="structmatrix.html#a68858fd3b57684ef38bdfce13c65d182">NbColumns</a>-NumColumns);
<a name="l00328"></a>00328   
<a name="l00329"></a>00329   <span class="keywordflow">for</span> (i = 0; i &lt; Result-&gt;<a class="code" href="structmatrix.html#a16ad614d15c6e81c0041e877b623c72d">NbRows</a>; i++) {
<a name="l00330"></a>00330     <a class="code" href="vector_8c.html#ab6eca9ad03a2f4a60dd79182289e0e0b">Vector_Copy</a>(M-&gt;<a class="code" href="structmatrix.html#a2c6d840d8d911ae95c2ae4fc96f4b5ba">p</a>[i], Result-&gt;<a class="code" href="structmatrix.html#a2c6d840d8d911ae95c2ae4fc96f4b5ba">p</a>[i], FirstColumnnumber);
<a name="l00331"></a>00331     <a class="code" href="vector_8c.html#ab6eca9ad03a2f4a60dd79182289e0e0b">Vector_Copy</a>(M-&gt;<a class="code" href="structmatrix.html#a2c6d840d8d911ae95c2ae4fc96f4b5ba">p</a>[i]+FirstColumnnumber+NumColumns, Result-&gt;<a class="code" href="structmatrix.html#a2c6d840d8d911ae95c2ae4fc96f4b5ba">p</a>[i]+FirstColumnnumber, 
<a name="l00332"></a>00332                 M-&gt;<a class="code" href="structmatrix.html#a68858fd3b57684ef38bdfce13c65d182">NbColumns</a>-NumColumns-FirstColumnnumber);
<a name="l00333"></a>00333   }
<a name="l00334"></a>00334   <span class="keywordflow">return</span> Result;
<a name="l00335"></a>00335 } <span class="comment">/* RemoveColumn */</span>
<a name="l00336"></a>00336 
<a name="l00337"></a>00337 <span class="comment">/*</span>
<a name="l00338"></a>00338 <span class="comment"> * Remove a column &apos;Columnnumber&apos; from matrix &apos;M&apos; and return the new matrix.</span>
<a name="l00339"></a>00339 <span class="comment"> */</span>
<a name="l00340"></a><a class="code" href="Matop_8h.html#a7866f34e302caaf90becd08b1245c126">00340</a> <a class="code" href="structmatrix.html">Matrix</a> *<a class="code" href="Matop_8c.html#a7866f34e302caaf90becd08b1245c126">RemoveColumn</a> (<a class="code" href="structmatrix.html">Matrix</a> *M, <span class="keywordtype">int</span> Columnnumber) {
<a name="l00341"></a>00341   
<a name="l00342"></a>00342   <a class="code" href="structmatrix.html">Matrix</a> *Result;
<a name="l00343"></a>00343   <span class="keywordtype">int</span> i;
<a name="l00344"></a>00344   
<a name="l00345"></a>00345   Result = <a class="code" href="matrix_8c.html#ac0b29e1d99a2823ad00b5f2157879d80">Matrix_Alloc</a> (M-&gt;<a class="code" href="structmatrix.html#a16ad614d15c6e81c0041e877b623c72d">NbRows</a>, M-&gt;<a class="code" href="structmatrix.html#a68858fd3b57684ef38bdfce13c65d182">NbColumns</a>-1);
<a name="l00346"></a>00346   
<a name="l00347"></a>00347   <span class="keywordflow">for</span> (i = 0; i &lt; Result-&gt;<a class="code" href="structmatrix.html#a16ad614d15c6e81c0041e877b623c72d">NbRows</a>; i++) {
<a name="l00348"></a>00348     <a class="code" href="vector_8c.html#ab6eca9ad03a2f4a60dd79182289e0e0b">Vector_Copy</a>(M-&gt;<a class="code" href="structmatrix.html#a2c6d840d8d911ae95c2ae4fc96f4b5ba">p</a>[i], Result-&gt;<a class="code" href="structmatrix.html#a2c6d840d8d911ae95c2ae4fc96f4b5ba">p</a>[i], Columnnumber);
<a name="l00349"></a>00349     <a class="code" href="vector_8c.html#ab6eca9ad03a2f4a60dd79182289e0e0b">Vector_Copy</a>(M-&gt;<a class="code" href="structmatrix.html#a2c6d840d8d911ae95c2ae4fc96f4b5ba">p</a>[i]+Columnnumber+1, Result-&gt;<a class="code" href="structmatrix.html#a2c6d840d8d911ae95c2ae4fc96f4b5ba">p</a>[i]+Columnnumber, 
<a name="l00350"></a>00350                 M-&gt;<a class="code" href="structmatrix.html#a68858fd3b57684ef38bdfce13c65d182">NbColumns</a>-1-Columnnumber);
<a name="l00351"></a>00351   }
<a name="l00352"></a>00352   <span class="keywordflow">return</span> Result;
<a name="l00353"></a>00353 } <span class="comment">/* RemoveColumn */</span>
<a name="l00354"></a>00354 
<a name="l00355"></a>00355 <span class="comment">/* </span>
<a name="l00356"></a>00356 <span class="comment"> * Given a Matrix M of dimesnion n * l and rank l1, find a unimodular matrix</span>
<a name="l00357"></a>00357 <span class="comment"> * &apos;Result&apos; such that the Vector Space spanned by M is the subset of the vector</span>
<a name="l00358"></a>00358 <span class="comment"> * Space spanned by the first l1 Rows of Result. The function returns the rank</span>
<a name="l00359"></a>00359 <span class="comment"> * l1 and the Matrix Result.  </span>
<a name="l00360"></a>00360 <span class="comment"> */</span>
<a name="l00361"></a><a class="code" href="Matop_8h.html#ad77e679cec7ff5e82f9d09d52e92db06">00361</a> <span class="keywordtype">int</span> <a class="code" href="Matop_8c.html#ad77e679cec7ff5e82f9d09d52e92db06">findHermiteBasis</a>(<a class="code" href="structmatrix.html">Matrix</a> *M, <a class="code" href="structmatrix.html">Matrix</a> **Result) {
<a name="l00362"></a>00362   
<a name="l00363"></a>00363   <span class="keywordtype">int</span> i, j;
<a name="l00364"></a>00364   <a class="code" href="structmatrix.html">Matrix</a> *C, *curMat, *temp1, *temp2;
<a name="l00365"></a>00365   <a class="code" href="structmatrix.html">Matrix</a> *H, *U;
<a name="l00366"></a>00366   <a class="code" href="structVector.html">Vector</a> *V;
<a name="l00367"></a>00367   <span class="keywordtype">int</span> dim, curDim, curVect,rank;
<a name="l00368"></a>00368   
<a name="l00369"></a>00369   <span class="keywordflow">if</span> (M-&gt;<a class="code" href="structmatrix.html#a16ad614d15c6e81c0041e877b623c72d">NbRows</a> == 0) {
<a name="l00370"></a>00370     Result[0] = <a class="code" href="Matop_8c.html#ac886b07103118bccddf1693e2bb9655f">Identity</a> (M-&gt;<a class="code" href="structmatrix.html#a68858fd3b57684ef38bdfce13c65d182">NbColumns</a>);
<a name="l00371"></a>00371     <span class="keywordflow">return</span> 0;
<a name="l00372"></a>00372   }
<a name="l00373"></a>00373   
<a name="l00374"></a>00374   <span class="keywordflow">if</span> (M-&gt;<a class="code" href="structmatrix.html#a16ad614d15c6e81c0041e877b623c72d">NbRows</a> &lt;= M-&gt;<a class="code" href="structmatrix.html#a68858fd3b57684ef38bdfce13c65d182">NbColumns</a>) {
<a name="l00375"></a>00375     <a class="code" href="NormalForms_8c.html#acd4e00bd353920b83e3f27a76909b2ed" title="Hermite : This function takes a Matrix as its input and finds its HNF ( Left form...">Hermite</a>(M, &amp;H, &amp;U);
<a name="l00376"></a>00376     
<a name="l00377"></a>00377     <span class="keywordflow">for</span> (i = 0; i &lt; H-&gt;<a class="code" href="structmatrix.html#a16ad614d15c6e81c0041e877b623c72d">NbRows</a>; i++)
<a name="l00378"></a>00378       <span class="keywordflow">if</span> (<a class="code" href="source_2arith_2arithmetique_8h.html#a827532f2140ae2aa96e46baebae09723">value_zero_p</a>(H-&gt;<a class="code" href="structmatrix.html#a2c6d840d8d911ae95c2ae4fc96f4b5ba">p</a>[i][i]))
<a name="l00379"></a>00379         <span class="keywordflow">break</span>;
<a name="l00380"></a>00380     
<a name="l00381"></a>00381     <span class="keywordflow">if</span> (i == H-&gt;<a class="code" href="structmatrix.html#a16ad614d15c6e81c0041e877b623c72d">NbRows</a>) {
<a name="l00382"></a>00382       Result[0] = <a class="code" href="Matop_8c.html#ab635a9108899776e30e1de03fe183915">Transpose</a>(U);
<a name="l00383"></a>00383       <a class="code" href="matrix_8c.html#afcb312b7c12a6997cd66964ecc34e1a6">Matrix_Free</a>(H);
<a name="l00384"></a>00384       <a class="code" href="matrix_8c.html#afcb312b7c12a6997cd66964ecc34e1a6">Matrix_Free</a>(U);
<a name="l00385"></a>00385       <span class="keywordflow">return</span>(i);
<a name="l00386"></a>00386     }
<a name="l00387"></a>00387     <a class="code" href="matrix_8c.html#afcb312b7c12a6997cd66964ecc34e1a6">Matrix_Free</a> (H);
<a name="l00388"></a>00388     <a class="code" href="matrix_8c.html#afcb312b7c12a6997cd66964ecc34e1a6">Matrix_Free</a> (U);
<a name="l00389"></a>00389   } 
<a name="l00390"></a>00390   
<a name="l00391"></a>00391   <span class="comment">/* Eliminating the Zero Rows  */</span>
<a name="l00392"></a>00392   
<a name="l00393"></a>00393   C = <a class="code" href="Matop_8c.html#a9d027e9fc6b85e6fa37fc284bf1b5e06">Matrix_Copy</a> (M);
<a name="l00394"></a>00394   <span class="keywordflow">for</span> (i = 0; i &lt; C-&gt;<a class="code" href="structmatrix.html#a16ad614d15c6e81c0041e877b623c72d">NbRows</a>; i++) {
<a name="l00395"></a>00395     <span class="keywordflow">for</span> (j = 0; j &lt; C-&gt;<a class="code" href="structmatrix.html#a68858fd3b57684ef38bdfce13c65d182">NbColumns</a>; j++)
<a name="l00396"></a>00396       <span class="keywordflow">if</span> (<a class="code" href="source_2arith_2arithmetique_8h.html#a47d32925340d2dc99ef2d4215080a60d">value_notzero_p</a>(C-&gt;<a class="code" href="structmatrix.html#a2c6d840d8d911ae95c2ae4fc96f4b5ba">p</a>[i][j]))
<a name="l00397"></a>00397         <span class="keywordflow">break</span>;
<a name="l00398"></a>00398     <span class="keywordflow">if</span> (j == C-&gt;<a class="code" href="structmatrix.html#a68858fd3b57684ef38bdfce13c65d182">NbColumns</a>) {
<a name="l00399"></a>00399       <a class="code" href="structmatrix.html">Matrix</a> *temp;
<a name="l00400"></a>00400       temp = <a class="code" href="Matop_8c.html#a4ef5342bc70d9c63714d1092a7668b03">RemoveRow</a>(C, i); 
<a name="l00401"></a>00401       <a class="code" href="matrix_8c.html#afcb312b7c12a6997cd66964ecc34e1a6">Matrix_Free</a>(C);
<a name="l00402"></a>00402       C = <a class="code" href="Matop_8c.html#a9d027e9fc6b85e6fa37fc284bf1b5e06">Matrix_Copy</a>(temp);
<a name="l00403"></a>00403       <a class="code" href="matrix_8c.html#afcb312b7c12a6997cd66964ecc34e1a6">Matrix_Free</a>(temp);
<a name="l00404"></a>00404       i --;
<a name="l00405"></a>00405     }
<a name="l00406"></a>00406   }
<a name="l00407"></a>00407   
<a name="l00408"></a>00408   <span class="comment">/* Eliminating the Redundant Rows */</span>
<a name="l00409"></a>00409   
<a name="l00410"></a>00410   curDim = 1;
<a name="l00411"></a>00411   curVect = 1;
<a name="l00412"></a>00412   dim = C-&gt;<a class="code" href="structmatrix.html#a68858fd3b57684ef38bdfce13c65d182">NbColumns</a>;
<a name="l00413"></a>00413   
<a name="l00414"></a>00414   curMat = <a class="code" href="matrix_8c.html#ac0b29e1d99a2823ad00b5f2157879d80">Matrix_Alloc</a>(1,C-&gt;<a class="code" href="structmatrix.html#a68858fd3b57684ef38bdfce13c65d182">NbColumns</a>);
<a name="l00415"></a>00415   <span class="keywordflow">for</span> (i = 0; i &lt; C-&gt;<a class="code" href="structmatrix.html#a68858fd3b57684ef38bdfce13c65d182">NbColumns</a>; i ++)
<a name="l00416"></a>00416     <a class="code" href="source_2arith_2arithmetique_8h.html#a864613888dc46f15679aa4f63e468f89">value_assign</a>(curMat-&gt;<a class="code" href="structmatrix.html#a2c6d840d8d911ae95c2ae4fc96f4b5ba">p</a>[0][i],C-&gt;<a class="code" href="structmatrix.html#a2c6d840d8d911ae95c2ae4fc96f4b5ba">p</a>[0][i]); 
<a name="l00417"></a>00417   
<a name="l00418"></a>00418   <span class="keywordflow">while</span>((curVect &lt; C-&gt;NbRows) &amp;&amp; (curDim &lt; dim)) {
<a name="l00419"></a>00419     <a class="code" href="structmatrix.html">Matrix</a> *temp;
<a name="l00420"></a>00420     temp = <a class="code" href="Matop_8c.html#a76461087aa1a40441a3dc174e8359b97">AddANullRow</a>(curMat);
<a name="l00421"></a>00421     <span class="keywordflow">for</span> (i = 0; i &lt; C-&gt;<a class="code" href="structmatrix.html#a68858fd3b57684ef38bdfce13c65d182">NbColumns</a>; i++)
<a name="l00422"></a>00422       <a class="code" href="source_2arith_2arithmetique_8h.html#a864613888dc46f15679aa4f63e468f89">value_assign</a>(temp-&gt;<a class="code" href="structmatrix.html#a2c6d840d8d911ae95c2ae4fc96f4b5ba">p</a>[temp-&gt;<a class="code" href="structmatrix.html#a16ad614d15c6e81c0041e877b623c72d">NbRows</a>-1][i],C-&gt;<a class="code" href="structmatrix.html#a2c6d840d8d911ae95c2ae4fc96f4b5ba">p</a>[curVect][i]);
<a name="l00423"></a>00423     
<a name="l00424"></a>00424     temp1 = <a class="code" href="Matop_8c.html#a76461087aa1a40441a3dc174e8359b97">AddANullRow</a>(temp);
<a name="l00425"></a>00425     temp2 = <a class="code" href="Matop_8c.html#a7d43e9c44b8c49cd9a542102042ad72e">AddANullColumn</a>(temp1);
<a name="l00426"></a>00426     rank = <a class="code" href="SolveDio_8c.html#a0f417a4dacdd52103cc96cbe93e038cb">SolveDiophantine</a>(temp2, &amp;U, &amp;V);
<a name="l00427"></a>00427     <span class="keywordflow">if</span> (rank == temp-&gt;<a class="code" href="structmatrix.html#a16ad614d15c6e81c0041e877b623c72d">NbRows</a>) {
<a name="l00428"></a>00428       <a class="code" href="matrix_8c.html#afcb312b7c12a6997cd66964ecc34e1a6">Matrix_Free</a>(curMat);
<a name="l00429"></a>00429       curMat = <a class="code" href="Matop_8c.html#a9d027e9fc6b85e6fa37fc284bf1b5e06">Matrix_Copy</a>(temp);
<a name="l00430"></a>00430       curDim ++;
<a name="l00431"></a>00431     }    
<a name="l00432"></a>00432     curVect ++;    
<a name="l00433"></a>00433     <a class="code" href="matrix_8c.html#afcb312b7c12a6997cd66964ecc34e1a6">Matrix_Free</a> (U);
<a name="l00434"></a>00434     <a class="code" href="vector_8c.html#a055608d1a3726b7cb26e3e8074764ba0">Vector_Free</a> (V);
<a name="l00435"></a>00435     <a class="code" href="matrix_8c.html#afcb312b7c12a6997cd66964ecc34e1a6">Matrix_Free</a> (temp1);
<a name="l00436"></a>00436     <a class="code" href="matrix_8c.html#afcb312b7c12a6997cd66964ecc34e1a6">Matrix_Free</a> (temp);
<a name="l00437"></a>00437     <a class="code" href="matrix_8c.html#afcb312b7c12a6997cd66964ecc34e1a6">Matrix_Free</a> (temp2);
<a name="l00438"></a>00438   }
<a name="l00439"></a>00439   <a class="code" href="matrix_8c.html#afcb312b7c12a6997cd66964ecc34e1a6">Matrix_Free</a>(C);
<a name="l00440"></a>00440   
<a name="l00441"></a>00441   <a class="code" href="NormalForms_8c.html#acd4e00bd353920b83e3f27a76909b2ed" title="Hermite : This function takes a Matrix as its input and finds its HNF ( Left form...">Hermite</a>(curMat, &amp;H, &amp;U);
<a name="l00442"></a>00442   rank = curMat-&gt;<a class="code" href="structmatrix.html#a16ad614d15c6e81c0041e877b623c72d">NbRows</a>;
<a name="l00443"></a>00443   <a class="code" href="matrix_8c.html#afcb312b7c12a6997cd66964ecc34e1a6">Matrix_Free</a>(curMat);
<a name="l00444"></a>00444   
<a name="l00445"></a>00445   Result[0] = <a class="code" href="Matop_8c.html#ab635a9108899776e30e1de03fe183915">Transpose</a> (U);
<a name="l00446"></a>00446   <a class="code" href="matrix_8c.html#afcb312b7c12a6997cd66964ecc34e1a6">Matrix_Free</a> (H);
<a name="l00447"></a>00447   <a class="code" href="matrix_8c.html#afcb312b7c12a6997cd66964ecc34e1a6">Matrix_Free</a> (U);
<a name="l00448"></a>00448   <span class="keywordflow">return</span> (rank);
<a name="l00449"></a>00449 } <span class="comment">/* findHermiteBasis */</span>
<a name="l00450"></a>00450 
<a name="l00451"></a>00451 
<a name="l00452"></a>00452 
<a name="l00453"></a>00453 
</pre></div></div>
<hr size="1"/><address style="text-align: right;"><small>Generated on Wed Nov 25 17:45:25 2009 for polylib by&nbsp;
<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.6.1 </small></address>
</body>
</html>
